
package require snit
package require snitwiz
     
namespace eval ::kwiz:: {
     variable wprops
     
     # Base window path
     variable bwinpath
     
     # Store all step snit variable step identifier
     variable stepidlist
     
     # Store the wizard id
     variable wizardid
     
     variable editedMesh
}

proc ::kwiz::Init {} {
     # ABSTRACT: Init namespace some variables
 
     # Init the base window path inside GiD        
     variable bwinpath
     set bwinpath ".gid.wtest"
     
     variable wprops
     set wprops(doomy) 0 
          
     variable editedMesh
     set editedMesh 1
     
     # Init step id list
     variable stepidlist [list]
}

# Init some namespace variables
::kwiz::Init


# Initialize default values if new button is pressed
proc ::kwiz::initdefvalues { } {
     variable wprops
     #wa "Defaulteando"
     # Default values step1
     if {[info exists wprops(TestType,TestType)]} {
          if {$wprops(TestType,TestType) ==""} {
               set wprops(TestType,TestType) $::defvals::dem::wizdata::TestType
          }
     } else {
          set wprops(TestType,TestType) $::defvals::dem::wizdata::TestType    
     }
     
     # Default values step2
     if {[info exists wprops(ExperimentType,ExperimentType)]} {
          if {$wprops(ExperimentType,ExperimentType) ==""} {
               set wprops(ExperimentType,ExperimentType) $::defvals::dem::wizdata::ExperimentType
          }
     } else {
          set wprops(ExperimentType,ExperimentType) $::defvals::dem::wizdata::ExperimentType    
     }
     
     # Default values step3 
     if {[info exists wprops(GeometryMesh,MeshType)]} {
          if {$wprops(GeometryMesh,MeshType) ==""} {
               set wprops(GeometryMesh,MeshType) $::defvals::dem::wizdata::MeshType
          }
     } else {
          set wprops(GeometryMesh,MeshType) $::defvals::dem::wizdata::MeshType    
     }
     
      # Set default material values
     ::kwiz::initmaterialdefaultvalues
     
     # Default values step5
     set plist [list CalculationTime DeltaTimeSelection DeltaTime LoadingVelocity]
     set pdflist [list $::defvals::dem::wizdata::CalculationTime $::defvals::dem::wizdata::DeltaTimeSelection \
                  $::defvals::dem::wizdata::DeltaTime $::defvals::dem::wizdata::LoadingVelocity]
   
     foreach pid $plist dfv $pdflist {
        
        if {[info exists wprops(GeneralSettings,$pid)]} {
            if {$wprops(GeneralSettings,$pid) ==""} {
                set wprops(GeneralSettings,$pid) $dfv
            }
        } else {
                set wprops(GeneralSettings,$pid) $dfv
        }
     }
     
     # Default values step6
     set plist [list Displacement Velocity TotalForces Rhs DampForces AppliedForces ContactSigma ContactTau \
                LocalContactForce FailureCriterionState SinglePostprocessFile PrintOutputFile PrintGraphData]
     set pdflist [list $::defvals::dem::wizdata::Displacement $::defvals::dem::wizdata::Velocity \
                  $::defvals::dem::wizdata::TotalForces $::defvals::dem::wizdata::Rhs $::defvals::dem::wizdata::DampForces \
                  $::defvals::dem::wizdata::AppliedForces $::defvals::dem::wizdata::ContactSigma $::defvals::dem::wizdata::ContactTau \
                  $::defvals::dem::wizdata::LocalContactForce $::defvals::dem::wizdata::FailureCriterionState \
                  $::defvals::dem::wizdata::SinglePostprocessFile $::defvals::dem::wizdata::PrintOutputFile \
                  $::defvals::dem::wizdata::PrintGraphData]
   
     foreach pid $plist dfv $pdflist {
        
        if {[info exists wprops(OutputSettings,$pid)]} {
            if {$wprops(OutputSettings,$pid) ==""} {
                set wprops(OutputSettings,$pid) $dfv
            }
        } else {
                set wprops(OutputSettings,$pid) $dfv
        }
     }
     
     # Default values step7
     set plist [list SelectOMPMPI NumberOfThreads]
     set pdflist [list $::defvals::dem::wizdata::SelectOMPMPI $::defvals::dem::wizdata::NumberOfThreads]
   
     foreach pid $plist dfv $pdflist {
        
        if {[info exists wprops(RunProblem,$pid)]} {
            if {$wprops(RunProblem,$pid) ==""} {
                set wprops(RunProblem,$pid) $dfv
            }
        } else {
                set wprops(RunProblem,$pid) $dfv
        }
     }
       
}

proc ::kwiz::WizardAfterLoad { filename } {
     if {[file root $filename] ne "kratos.spd"} {
          if {[winfo exists ".gid.wtest.w.layoutFrame.wiz.layout"]} {
               ::kwiz::checkWizardAction ".gid.wtest.w.layoutFrame.wiz.layout"
          }
     }
     
}

proc ::kwiz::SetMeshLenDiam { } {
     variable wprops
      set meshtype $wprops(GeometryMesh,MeshType)
     # wa $meshtype
     switch $meshtype {
             1 {
                     set wprops(GeometryMesh,ProbeLength) 0.3
                     set wprops(GeometryMesh,ProbeDiameter) 0.15		
             }
             2 {
                     set wprops(GeometryMesh,ProbeLength) 0.3
                     set wprops(GeometryMesh,ProbeDiameter) 0.15			
             }
             3 {
                     set wprops(GeometryMesh,ProbeLength) 0.3
                     set wprops(GeometryMesh,ProbeDiameter) 0.15		
             }
             4 {
                     set wprops(GeometryMesh,ProbeLength) 0.04826 
                     set wprops(GeometryMesh,ProbeDiameter) 0.0254		
             }
             5 {
                     set wprops(GeometryMesh,ProbeLength) 0.04826 
                     set wprops(GeometryMesh,ProbeDiameter) 0.0254	
             }
             6 {
                     set wprops(GeometryMesh,ProbeLength) 0.04826 
                     set wprops(GeometryMesh,ProbeDiameter) 0.0254			
             }
     
     }
     # wa "$wprops(GeometryMesh,ProbeLength) $wprops(GeometryMesh,ProbeDiameter)"
}

proc ::kwiz::NextEvent {stepnumber} {
	 variable wprops
	 
     if {$stepnumber ne "0"} {
          set StepList [list "TestType" "ExperimentType" "GeometryMesh" "MaterialParameters" "GeneralSettings" "OutputSettings" "RunProblem"]
          set stepId [lindex $StepList $stepnumber]
          if {$stepnumber eq "2"} {
               ::kwiz::SetMeshLenDiam
          }
          #wa "Next from $stepId"
          ::kfiles::SaveWizardDataStep $stepId
          
          ::kfiles::SaveWizardToSPDStep $stepId
     }
}

proc ::kwiz::SaveActiveWizardtoSPD { filename } {
     variable wizardid
     
     set cxpath "DEM//c.Wizards"
     set wizards [::xmlutils::setXmlContainerIds $cxpath "Item"]
     
     foreach wiz $wizards {
          set cxpath "DEM//c.Wizards//i.$wiz"
          # wa "wiz $wiz"
          # wa "Id $wizardid"
          if {$wiz eq $wizardid} {
               ::xmlutils::setXml $cxpath "dv" write 1
               set wizardFile "[string range $filename 0 [expr [string length $filename] - 5]].$wizardid.wiz"
               set filen [::KUtils::GiveProjectName] 
               ::xmlutils::setXml $cxpath "rpath" write "$filen.$wizardid.wiz"
          } else {
               ::xmlutils::setXml $cxpath "dv" write 0
          }
     }
     return $wizardFile
}

proc ::kwiz::ValidateDV {idv dv} {
     
     set Reslist [list "Displacement" "Velocity" "TotalForces" "Rhs" "DampForces" "AppliedForces" "ContactSigma" "ContactTau" "LocalContactForce" "FailureCriterionState" "SinglePostprocessFile"]
     if {$idv eq "ExperimentType"} {
          if {$dv eq "Uniaxial compression strength"} {return "UCS"}
          if {$dv eq "Uniaxial strain compaction"} {return "Oedometric"}
     } elseif {$idv in $Reslist} {
          if {$dv eq "1"} {
               return "Yes"
          } else { return "No" }
     }
     return $dv
}


# Action for new and load buttons (TestType)
proc ::kwiz::wizardAction {w b} {
     variable wprops
     
     catch {destroy $w.b1}
     catch {destroy $w.b2}
     
     if { $b == 1  } {
          # Poner todos los valores por defecto
          GiD_Process Files SaveAs
          #::kwiz::initdefvalues
          
     } elseif { $b == 2  } {
         # Cargar valores de archivo
         set wprops(TestType,WizardType) 2
         ::kfiles::LoadWizardData
         #::kwiz::TopWindow
     }
     
          
     
     # Set the widgets
     set wprops(TestType,WizardType) $b
     set img1 [::WinUtils::GetImage MaterialTest2.gif]
     set img2 [::WinUtils::GetImage CuttingTest2.gif]
     set but1 [ttk::checkbutton $w.b1 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep1 $w" -variable ::kwiz::wprops(TestType,TestType) -onvalue 1]
     set but2 [ttk::checkbutton $w.b2 -style TMenubutton.Toolbutton -image $img2 -command "::kwiz::buttonPushedStep1 $w" -variable ::kwiz::wprops(TestType,TestType) -onvalue 2]
     
     # Check image buttons
     ::kwiz::checkImageStep1 $w
     
     # Set the grid
     grid $but1 -column 1 -row 2 
     grid $but2 -column 2 -row 2
     
     
     # Check image buttons
     ::kwiz::checkImageStep1 $w
     ::kwiz::CheckNextButtonStep1
     ::kwiz::checkWizardAction $w
     
     # wa "filename [::kwiz::CheckProjName] "
     if {[::kwiz::CheckProjName] eq ""} {
          ::kwiz::HideButtonsStep1 $w
     } else {
          
          ::kwiz::checkWizardAction $w
     }
}

proc ::kwiz::CheckProjName { } {
     
     set ProjectName [GiD_Info Project "ModelName"]
     
     if {$ProjectName eq "UNNAMED"} {
          set ProjectName ""
     }
     return $ProjectName
}

proc ::kwiz::HideButtonsStep1 { w } {
     
     if {[info exists wprops(TestType,TestType) ]} {
          set wprops(TestType,TestType) 0
     }
     ::kwiz::CheckNextButtonStep1
     catch {destroy $w.b1}
     catch {destroy $w.b2}
}

proc ::kwiz::CheckNextButtonStep1 { } {
     if {[info exists wprops(TestType,TestType) ]} {
          if { $wprops(TestType,TestType) == 1 } {
               .gid.wtest.w buttonstate next normal
          } elseif { $wprops(TestType,TestType) == 2 } {
               .gid.wtest.w buttonstate next normal
          } else {
               .gid.wtest.w buttonstate next disabled
          }
     }
}
  

# Check variables for new and load buttons (Step1)
proc ::kwiz::checkWizardAction { w } {
     variable wprops
     
     if {[info exists wprops(TestType,WizardType)]} {
          if {$wprops(TestType,WizardType) ne "0"} {
               ::kwiz::HideButtonsStep1 $w
               # Set the widgets
               set img1 [::WinUtils::GetImage MaterialTest2.gif]
               set img2 [::WinUtils::GetImage CuttingTest2.gif]
               set but1 [ttk::checkbutton $w.b1 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep1 $w" -variable ::kwiz::wprops(TestType,TestType) -onvalue 1]
               set but2 [ttk::checkbutton $w.b2 -style TMenubutton.Toolbutton -image $img2 -command "::kwiz::buttonPushedStep1 $w" -variable ::kwiz::wprops(TestType,TestType) -onvalue 2]
               
               # Check image buttons
               ::kwiz::checkImageStep1 $w
               ::kwiz::CheckNextButtonStep1
               # Set the grid
               grid $but1 -column 1 -row 2 
               grid $but2 -column 2 -row 2

          }
     }
}

# Proc for check image buttons
proc ::kwiz::checkImageStep1 { w } {
     variable wprops
     set img3 [::WinUtils::GetImage MaterialTestSel.gif]
     set img4 [::WinUtils::GetImage CuttingTestSel.gif]
     if {[info exists wprops(TestType,TestType) ]} {
     
          if { $wprops(TestType,TestType) == 1 } {
               set ::kwiz::wizardid "compressiontest"
               $w.b1 configure -image $img3
              .gid.wtest.w buttonstate next normal
          }
          if { $wprops(TestType,TestType) == 2 } {
               set ::kwiz::wizardid "cutting"
               $w.b2 configure -image $img4
              .gid.wtest.w buttonstate next normal
          }
     } else {
          .gid.wtest.w buttonstate next disabled
     }
}


proc ::kwiz::checkImageStep2 { w } {
    variable wprops
     set imgUCSm [::WinUtils::GetImage UCSMarked.gif]
     set imgTrim [::WinUtils::GetImage TriMarked.gif]
     set imgUSCm [::WinUtils::GetImage USCMarked.gif]
     set imgHydm [::WinUtils::GetImage TriMarked.gif]
     set imgBTSm [::WinUtils::GetImage BTSMarked.gif]
     
    if {[info exists wprops(ExperimentType,ExperimentType) ]} {
        if { $wprops(ExperimentType,ExperimentType) eq "UCS" } {
            $w.b1 configure -image $imgUCSm
        }
        if { $wprops(ExperimentType,ExperimentType) eq "Triaxial" } {
            $w.b2 configure -image $imgTrim
        }
        if { $wprops(ExperimentType,ExperimentType) eq "Oedometric" } {
            $w.b3 configure -image $imgUSCm
        }
        if { $wprops(ExperimentType,ExperimentType) eq "Hydrostatic" } {
            $w.b4 configure -image $imgHydm
        }
        if { $wprops(ExperimentType,ExperimentType) eq "BTS" } {
            $w.b5 configure -image $imgBTSm
        } 
    }
}

proc ::kwiz::checkImageStep3 { w } {
    variable wprops
    
      
    set img1 [::WinUtils::GetImage bts_mesh_marked.gif]
    set img2 [::WinUtils::GetImage ucs_mesh_marked.gif]
    if {[info exists wprops(GeometryMesh,MeshType) ]} {
     # wa "Checando $wprops(GeometryMesh,MeshType)"
        if { $wprops(ExperimentType,ExperimentType) eq "BTS" } {
            foreach i [list 1 2 3] {
                if { $wprops(GeometryMesh,MeshType) == $i } {
                $w.b$i configure -image $img1
                }
            }
        } else {
            foreach i [list 1 2 3 4 5 6] {
                if { $wprops(GeometryMesh,MeshType) == $i } {
                $w.b$i configure -image $img2
                }
            }  
        }
    }
}

# Change button images step 1
proc ::kwiz::buttonPushedStep1 {cpath} {
    variable wprops
    variable wizardid
    variable bwinpath
    
     set img1 [::WinUtils::GetImage MaterialTest2.gif]
     set img2 [::WinUtils::GetImage CuttingTest2.gif]
     set img3 [::WinUtils::GetImage MaterialTestSel.gif]
     set img4 [::WinUtils::GetImage CuttingTestSel.gif]
     
     if { $wprops(TestType,TestType) == 1 } {
          
         .gid.wtest.w buttonstate next normal
         $cpath.b1 configure -image $img3
         $cpath.b2 configure -image $img2
          set wizardid "compressiontest"
     } elseif { $wprops(TestType,TestType) == 2 } {
         .gid.wtest.w buttonstate next normal
         $cpath.b1 configure -image $img1
         $cpath.b2 configure -image $img4
         set wizardid "cutting"
     } else {
         $cpath.b1 configure -image $img1
         $cpath.b2 configure -image $img2
         .gid.wtest.w buttonstate next disabled
     }
     if { $wprops(TestType,TestType) == 0 } {
         $cpath.b1 configure -image $img1
         $cpath.b2 configure -image $img2
         .gid.wtest.w buttonstate next disabled
     }
    
}



proc ::kwiz::buttonPushedStep2 {cpath id} {
     variable wprops
     global dir
     
    variable editedMesh
    set editedMesh 1
	 
	 # selected images
     set imgUCSs [::WinUtils::GetImage UCSSelected.gif]
     set imgTris [::WinUtils::GetImage TriSelected.gif]
     set imgUSCs [::WinUtils::GetImage USCSelected.gif]
     set imgHyds [::WinUtils::GetImage TriSelected.gif]
     set imgBTSs [::WinUtils::GetImage BTSSelected.gif]
	 
	 # marked images 
     set imgUCSm [::WinUtils::GetImage UCSMarked.gif]
     set imgTrim [::WinUtils::GetImage TriMarked.gif]
     set imgUSCm [::WinUtils::GetImage USCMarked.gif]
     set imgHydm [::WinUtils::GetImage TriMarked.gif]
     set imgBTSm [::WinUtils::GetImage BTSMarked.gif]
        
        # Si no hay boton apretado deselecciono todas las imagenes
     $cpath.b1 configure -image $imgUCSs
     $cpath.b2 configure -image $imgTris
     $cpath.b3 configure -image $imgUSCs
     $cpath.b4 configure -image $imgHyds
     $cpath.b5 configure -image $imgBTSs
     .gid.wtest.w buttonstate next disabled
     
     if { $wprops(ExperimentType,ExperimentType) ne 0 } {
     # Si hay boton apretado selecciono la imagen correspondiente
          
          .gid.wtest.w buttonstate next active
          switch $id {
               1 {
                    $cpath.b1 configure -image $imgUCSm
               }
               2 {
                    $cpath.b2 configure -image $imgTrim
               }
               3 {
                    $cpath.b3 configure -image $imgUSCm
               }
               4 {
                    $cpath.b4 configure -image $imgHydm
               }
               5 {
                    $cpath.b5 configure -image $imgBTSm
               }
          }
     } 
}

# Change button images step 2
proc ::kwiz::buttonPushedStep2b {cpath id} {
     variable wprops
     global dir
     variable editedMesh
    set editedMesh 1
     
     set img1 [::WinUtils::GetImage ExpSelected.gif]
     set img2 [::WinUtils::GetImage ExpMarked.gif]
        
        
        if { $wprops(ExperimentType,ExperimentType) == 0 } {
            # Si no hay boton apretado deselecciono todas las imagenes
            .gid.wtest.w buttonstate next disabled
            foreach i [list 1 2 3 4 5] {
            $cpath.b$i configure -image $img1
            }
        } else {
            # Si hay boton apretado selecciono la imagen correspondiente
            foreach i [list 1 2 3 4 5] {
                
                if { $i == $id } {
                    .gid.wtest.w buttonstate next normal
                    $cpath.b$i configure -image $img2
                } else {
                    $cpath.b$i configure -image $img1
                }
            }
        }
        
}
# Change button images step 3
proc ::kwiz::buttonPushedStep3 {cpath} {
     variable wprops
     global dir
     
     variable editedMesh
    set editedMesh 1
     
     set img1 [::WinUtils::GetImage bts_meshgrey.gif]
     set img2 [::WinUtils::GetImage bts_mesh_marked.gif]  
     set img3 [::WinUtils::GetImage ucs_mesh_marked.gif]
     set img4 [::WinUtils::GetImage ucs_meshgrey.gif]     
     if { $wprops(ExperimentType,ExperimentType) eq "BTS" } {
        
        foreach i [list 1  3] {
            if { $wprops(GeometryMesh,MeshType) == $i } {
                .gid.wtest.w buttonstate next normal
                $cpath.b$i configure -image $img2
            } else {
                $cpath.b$i configure -image $img1
            }
        }
        if { $wprops(GeometryMesh,MeshType) ==0 } {
            .gid.wtest.w buttonstate next disabled
        }
        #$cpath.b2 configure -state disabled
     } else {
        
        foreach i [list 1 2 3 4 5 6] {
            if { $wprops(GeometryMesh,MeshType) == $i } {
                .gid.wtest.w buttonstate next normal
                $cpath.b$i configure -image $img3
            } else {
                $cpath.b$i configure -image $img4
            }
        }
        if { $wprops(GeometryMesh,MeshType) ==0 } {
            .gid.wtest.w buttonstate next disabled
        }
     }    
}

# Set material properties default values
proc ::kwiz::initmaterialdefaultvalues {} {
    variable wprops
   set plist [list Density YoungModulus PoissonRatio ParticleFrictionAngle LCS1 LCS2 LCS3 YRC1 YRC2 YRC3 PlasticYoungModulus PlasticYieldStress \
              DamageDeformationFactor TangentialStrength NormalTensileStrength InternalFrictionAngleCoeff]
   set pdflist [list $::defvals::dem::wizmaterial::Density $::defvals::dem::wizmaterial::YoungModulus \
                $::defvals::dem::wizmaterial::PoissonRatio $::defvals::dem::wizmaterial::ParticleFrictionAngle \
                $::defvals::dem::wizmaterial::LCS1 $::defvals::dem::wizmaterial::LCS2 $::defvals::dem::wizmaterial::LCS3 \
                $::defvals::dem::wizmaterial::YRC1 $::defvals::dem::wizmaterial::YRC2 $::defvals::dem::wizmaterial::YRC3 \
                $::defvals::dem::wizmaterial::PlasticYoungModulus $::defvals::dem::wizmaterial::PlasticYieldStress \
                $::defvals::dem::wizmaterial::DamageDeformationFactor $::defvals::dem::wizmaterial::TangentialStrength \
                $::defvals::dem::wizmaterial::NormalTensileStrength $::defvals::dem::wizmaterial::InternalFrictionAngleCoeff]
   
    foreach pid $plist dfv $pdflist {
        
        if {[info exists wprops(MaterialParameters,$pid)]} {
            if {$wprops(MaterialParameters,$pid) ==""} {
                set wprops(MaterialParameters,$pid) $dfv
            }
        } else {
                set wprops(MaterialParameters,$pid) $dfv
        }
   }
}

# Combo DeltaTime GeneralSettings
proc ::kwiz::DeltaTimeSelection {w combo} {
     variable wprops
     set DeltaTimeSel [$combo get]
     # wa "Deltatime $DeltaTimeSel"
    if { $DeltaTimeSel == "Fixed" } {
         $w.lf1.l4 configure -state normal
         $w.lf1.e2 configure -state normal
         $w.lf1.l8 configure -state normal
         set ::kwiz::wprops(GeneralSettings,DeltaTimeSelection) "Fixed"
    } else {
         # set wprops(GeneralSettings,DeltaTime) $::defvals::dem::wizdata::DeltaTime
         $w.lf1.l4 configure -state disabled
         $w.lf1.e2 configure -state disabled
         $w.lf1.l8 configure -state disabled
         set ::kwiz::wprops(GeneralSettings,DeltaTimeSelection) "Automatic"
    }
}

# Combo DeltaTime GeneralSettings
proc ::kwiz::ParallelTypeSelection {w combo} {
     variable wprops
     set ParTypeSel [$combo get]
     
    if { $ParTypeSel == "OpenMP" } {
         set ::kwiz::wprops(RunProblem,SelectOMPMPI) "OpenMP"
    } else {
         set ::kwiz::wprops(RunProblem,SelectOMPMPI) "MPi"
    }
}

proc ::kwiz::bodystep1 { win } {
    variable wprops
     # Set the widgets
     set img3 [::WinUtils::GetImage MaterialTestSel.gif]
     set img4 [::WinUtils::GetImage CuttingTestSel.gif]
     set but3 [ttk::button $win.b3 -text "New project" -command "::kwiz::wizardAction $win 1" -width 20]
     set but4 [ttk::button $win.b4 -text "Load project" -command "::kwiz::wizardAction $win 2" -width 20]
     set lab2 [ttk::label $win.l -text "Select test:"]
    
     # Check if new or load buttons have been used
     ::kwiz::checkWizardAction $win
     
     # Set the grid
     grid $lab2 -column 0 -row 0
     grid $but3 -column 1 -row 1
     grid $but4 -column 2 -row 1
     
     # Configure the grid
     grid columnconfigure $win 0 -pad 20
     grid columnconfigure $win 1 -pad 50 -minsize 220
     grid columnconfigure $win 2 -pad 0 -minsize 220
     grid rowconfigure $win 1 -pad 40
     grid rowconfigure $win 2 -pad 40
}



proc ::kwiz::bodystep2 { win } {
     variable wprops
    if {$wprops(TestType,TestType) == 1} {
      # MATERIAL TEST
      
     # Set the widgets
     
     set imgUCSm [::WinUtils::GetImage UCSSelected.gif]
     set imgTrim [::WinUtils::GetImage TriSelected.gif]
     set imgUSCm [::WinUtils::GetImage USCSelected.gif]
     set imgHydm [::WinUtils::GetImage TriSelected.gif]
     set imgBTSm [::WinUtils::GetImage BTSSelected.gif]
     
     set lab [ttk::label $win.l -text "Select experiment type:"]
     set lab1 [ttk::label $win.l1 -text "Uniaxial compression strength" -wraplength 150]
     set lab2 [ttk::label $win.l2 -text "Triaxial" -wraplength 150]
     set lab3 [ttk::label $win.l3 -text "Uniaxial strain compaction" -wraplength 150]
     set lab4 [ttk::label $win.l4 -text "Hydrostatic" -wraplength 150]
     set lab5 [ttk::label $win.l5 -text "BTS" -wraplength 150]
     set but1 [ttk::checkbutton $win.b1 -style TMenubutton.Toolbutton -image $imgUCSm -command "::kwiz::buttonPushedStep2 $win 1" -variable ::kwiz::wprops(ExperimentType,ExperimentType) -onvalue "UCS"] 
     set but2 [ttk::checkbutton $win.b2 -style TMenubutton.Toolbutton -image $imgTrim -command "::kwiz::buttonPushedStep2 $win 2" -variable ::kwiz::wprops(ExperimentType,ExperimentType) -onvalue "Triaxial"]
     set but3 [ttk::checkbutton $win.b3 -style TMenubutton.Toolbutton -image $imgUSCm -command "::kwiz::buttonPushedStep2 $win 3" -variable ::kwiz::wprops(ExperimentType,ExperimentType) -onvalue "Oedometric"]
     set but4 [ttk::checkbutton $win.b4 -style TMenubutton.Toolbutton -image $imgHydm -command "::kwiz::buttonPushedStep2 $win 4" -variable ::kwiz::wprops(ExperimentType,ExperimentType) -onvalue "Hydrostatic"] 
     set but5 [ttk::checkbutton $win.b5 -style TMenubutton.Toolbutton -image $imgBTSm -command "::kwiz::buttonPushedStep2 $win 5" -variable ::kwiz::wprops(ExperimentType,ExperimentType) -onvalue "BTS"]
    
    
    # Set def MeshType
     if {[info exists wprops(GeometryMesh,MeshType) ]} {
          if {$wprops(GeometryMesh,MeshType) eq 0} {
               set wprops(GeometryMesh,MeshType) 1
          }
     }
     
     # Check image buttons
     ::kwiz::checkImageStep2 $win
     
     
     # Set the grid
     grid $lab -column 0 -row 0
     grid $but1 -column 0 -row 2
     grid $but2 -column 1 -row 2
     grid $but3 -column 2 -row 2
     grid $but4 -column 0 -row 4
     grid $but5 -column 1 -row 4
     grid $lab1 -column 0 -row 3
     grid $lab2 -column 1 -row 3
     grid $lab3 -column 2 -row 3
     grid $lab4 -column 0 -row 5
     grid $lab5 -column 1 -row 5    
     
     # Configure the grid
     grid rowconfigure $win 1 -minsize 15
     grid columnconfigure $win 0 -pad 20
     grid columnconfigure $win 1 -pad 0
     grid columnconfigure $win 2 -pad 20
     
    } else {
      # CUTTING TEST
     
          set lab2 [ttk::label $win.l1 -text "TODAVIA POR IMPLEMENTAR!"]
          
          pack $lab2
        
    }
 
}
 
proc ::kwiz::bodystep3 { win } {
     global dir
     variable wprops
     if { $wprops(ExperimentType,ExperimentType) eq "BTS" } {
        # BTS EXPERIMENT
       
          # Set the widgets  
          set img1 [::WinUtils::GetImage bts_meshgrey.gif]
          set img2 [::WinUtils::GetImage bts_mesh_marked.gif]
          set lab0 [ttk::label $win.l0 -text "Select Geometry & Mesh:"]
          set lab1 [ttk::label $win.l1 -text "Cylinder 27000 elements\nD=150 mm, L=90 mm" -wraplength 150]
          #set lab2 [ttk::label $win.l2 -text "Cylinder 40000 elements\nD=37.8 mm, L=21.9 mm" -wraplength 150]
          set lab3 [ttk::label $win.l3 -text "Cylinder 16000 elements\nD=37.8 mm, L=21.9 mm" -wraplength 150]
          set labspace [ttk::label $win.ls -text ""]
          set but1 [ttk::checkbutton $win.b1 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 1] 
          #set but2 [ttk::checkbutton $win.b2 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 2]
          set but3 [ttk::checkbutton $win.b3 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 3]
              
          # Set def MeshType
           if {$wprops(ExperimentType,ExperimentType) eq "BTS"} {
               set ::kwiz::wprops(GeometryMesh,MeshType) 1
           }
    
         # Check image buttons
          ::kwiz::checkImageStep3 $win
          
          # Set the grid 
          grid $lab0 -column 0 -row 0
          grid $labspace -column 0 -row 1
          grid $but1 -column 0 -row 2
          #grid $but2 -column 1 -row 2
          grid $but3 -column 2 -row 2
          grid $lab1 -column 0 -row 3 
          #grid $lab2 -column 1 -row 3
          grid $lab3 -column 2 -row 3
          
          # Grid configure
          grid columnconfigure $win 0 -pad 80
          grid columnconfigure $win 1 -pad 0
          grid columnconfigure $win 2 -pad 80
        
    } else {
        # OTHER EXPERIMENTS
    
     # Set the widgets
     set img1 [::WinUtils::GetImage ucs_meshgrey.gif]
     set img2 [::WinUtils::GetImage ucs_mesh_marked.gif]
     set lab0 [ttk::label $win.l0 -text "Select Geometry & Mesh:"]
     set lab1 [ttk::label $win.l1 -text "Cylinder 13000 elements\nD=150 mm, L=300 mm" -wraplength 150]
     set lab2 [ttk::label $win.l2 -text "Cylinder 37000 elements\nD=150 mm, L=300 mm" -wraplength 150]
     set lab3 [ttk::label $win.l3 -text "Cylinder 70000 elements\nD=150 mm, L=300 mm" -wraplength 150]
     set lab4 [ttk::label $win.l4 -text "Cylinder 16000 elements\nD=25.4 mm, L=48.26 mm" -wraplength 150]
     set lab5 [ttk::label $win.l5 -text "Cylinder 42000 elements\nD=25.4 mm, L=48.26 mm" -wraplength 150]
     set lab6 [ttk::label $win.l6 -text "Cylinder 60000 elements\nD=25.4 mm, L=48.26 mm" -wraplength 150]
     set labspace [ttk::label $win.ls -text ""]
     set but1 [ttk::checkbutton $win.b1 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 1] 
     set but2 [ttk::checkbutton $win.b2 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 2]
     set but3 [ttk::checkbutton $win.b3 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 3]
     set but4 [ttk::checkbutton $win.b4 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 4]
     set but5 [ttk::checkbutton $win.b5 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 5]
     set but6 [ttk::checkbutton $win.b6 -style TMenubutton.Toolbutton -image $img1 -command "::kwiz::buttonPushedStep3 $win" -variable ::kwiz::wprops(GeometryMesh,MeshType) -onvalue 6]
     
     # Check image buttons
     ::kwiz::checkImageStep3 $win
     
     # Set the grid 
     grid $lab0 -column 0 -row 0
     grid $labspace -column 0 -row 1
     grid $but1 -column 0 -row 2
     grid $but2 -column 1 -row 2
     grid $but3 -column 2 -row 2
     grid $lab1 -column 0 -row 3 
     grid $lab2 -column 1 -row 3
     grid $lab3 -column 2 -row 3
     grid $but4 -column 0 -row 4
     grid $but5 -column 1 -row 4
     grid $but6 -column 2 -row 4
     grid $lab4 -column 0 -row 5
     grid $lab5 -column 1 -row 5
     grid $lab6 -column 2 -row 5
     
     # Grid configure
     grid columnconfigure $win 0 -pad 80
     grid columnconfigure $win 1 -pad 0
     grid columnconfigure $win 2 -pad 80
    }
}

proc ::kwiz::OpenFile { what } {
     variable bwinpath
     set txt1 [= "Dempack Wizard Material files"]; set l1 [list "$txt1" ".kwm"]
     set mfilename [Browser-ramR file $what $bwinpath [= "Export material"] "" [list $l1] ".kwm" 0]
     
     # WarnWinText "mfilename:$mfilename"
     set cext "kwm"
     if {$mfilename != "" }  {
         set currext [string tolower [file extension $mfilename]]
         if {$currext != ".kwm" } {
             set mfilename "${mfilename}.kwm"
         }
     }
     return $mfilename
}

# -np- source {D:\PROYECTOS\Kdem\dem-drill\gid_interface\kratos.gid\scripts\wizards\demwizardbody.tcl}
proc ::kwiz::exportmaterial { win } { 
     global KPriv
     variable wprops
     variable wizardid
     
     set wizid $wizardid
     set stepId "MaterialParameters"
     
     ::kfiles::SaveWizardDataStep $stepId
     set filename [::kwiz::OpenFile "write"]
     set xmlData $KPriv(xmlWiz)
     set xmlRoot "/Wizard\[@wizardid='$wizid'\]"
     
     set path "/${xmlRoot}/Steps"
     set stepNode [$xmlData selectNodes "$path/Step\[@id='$stepId'\]"]
     # wa [$stepNode getAttribute id ""]
     set dataNodes [$xmlData selectNodes "$path/Step\[@id='$stepId'\]/Data"]
     
     foreach dataNode $dataNodes {
          # wa "stepId:$stepId"
          foreach node [$dataNode childNodes] {
               
               # For nodes with no children
               if {([$node nodeName] eq "Item") && (![$node hasChildNodes])} {
                    set idv [$node getAttribute idv ""]
                    # Assign the current variable value to the xml node
                    set dv [$node getAttribute dv ""]
                    # wwt "node:$node idv:$idv dv:$dv"
                    
                    set path "/Kratos_Wiz_Mat"
                    set parent [$KPriv(xmlWizMat) selectNodes $path]
                    set material [$parent childNodes]
                    foreach node [$material childNodes] {
                         if {[$node getAttribute idv ""] eq $idv} {
                              $node setAttribute dv $dv
                              # wa "id: $idv dv: $dv"
                         }
                    }
               }
          }
     }
     ::xmlutils::writeFile "${filename}" $KPriv(dir) $KPriv(encrXmlWizMat) $KPriv(xmlDocWizMat) $KPriv(RDConfig) 0
}


proc ::kwiz::importmaterial { win } { 
     global KPriv
     variable wprops
     variable wizardid
     
     set wizid $wizardid
     set stepId "MaterialParameters"
     
     set filename [::kwiz::OpenFile "read"]
     set xmlArray [::xmlutils::openFile "." "$filename"]
     
     set KPriv(xmlWizMat) [lindex $xmlArray 0]
     set KPriv(encrXmlWizMat) [lindex $xmlArray 1]
     set KPriv(xmlDocWizMat) [lindex $xmlArray 2]
     
     set xmlData $KPriv(xmlWiz)
     set xmlRoot "/Wizard\[@wizardid='$wizid'\]"
     
     set path "/${xmlRoot}/Steps"
     set stepNode [$xmlData selectNodes "$path/Step\[@id='$stepId'\]"]
      #wa [$stepNode getAttribute id ""]
     set dataNodes [$xmlData selectNodes "$path/Step\[@id='$stepId'\]/Data"]
     
     foreach dataNode $dataNodes {
          # wa "stepId:$stepId"
          foreach node [$dataNode childNodes] {
               
               # For nodes with no children
               if {([$node nodeName] eq "Item") && (![$node hasChildNodes])} {
                    set idv [$node getAttribute idv ""]
                    # Assign the current variable value to the xml node
                                        
                    set path "/Kratos_Wiz_Mat"
                    set parent [$KPriv(xmlWizMat) selectNodes $path]
                    set material [$parent childNodes]
                    foreach node2 [$material childNodes] {
                         if {[$node2 getAttribute idv ""] eq $idv} {
                              set dv [$node2 getAttribute dv ""]
                              $node setAttribute dv $dv
                              # wa "id: $idv dv: $dv"
                         }
                    }
               }
          }
     }
     ::kfiles::ImportWizardDataStep $stepId
}

proc ::kwiz::bodystep4 { win } {
    variable wprops
     
     # Set the widgets
     set img1 [::WinUtils::GetImage MaterialPar1b.gif]
     #set img2 [::WinUtils::GetImage MaterialPar2.gif]
     set fr1 [ttk::frame $win.fr1 -borderwidth 0]
     set fr2 [ttk::frame $win.fr2 -borderwidth 0]
     set but1 [ttk::button $fr1.b1 -text [= "Export material"] -command [list ::kwiz::exportmaterial $win]]
     set but2 [ttk::button $fr1.b2 -text [= "Import material"] -command [list ::kwiz::importmaterial $win]]
     set labIm [ttk::label $fr2.lIm -image $img1]
     #set labIm2 [ttk::label $fr2.lIm2 -image $img2]
     set labfr1 [ttk::labelframe $fr1.lfr1 -text [= "Material"] -padding 10 -width 40 -height 200 ]
     set labfr2 [ttk::labelframe $fr1.lfr2 -text [= "Non-linear elasticity"] -padding 10 -width 200 -height 100]
     set labfr3 [ttk::labelframe $fr1.lfr3 -text [= "1D plasticity and damage"] -padding 10 -width 200 -height 100]
     set labfr4 [ttk::labelframe $fr1.lfr4 -text [= "Failure criterion"] -padding 10 -width 200 -height 100]
     set lab0 [ttk::label $fr1.l0 -text [= "Define material parameters:"]]
     set lab1 [ttk::label $fr1.lfr1.l1 -text [= "Density:"]]
     set lab2 [ttk::label $fr1.lfr1.l2 -text [= "Young modulus:"]]
     set lab3 [ttk::label $fr1.lfr1.l3 -text [= "Poisson ratio:"]]
     set lab4 [ttk::label $fr1.lfr1.l4 -text [= "Dynamic friction coeff:"]]
     set lab5 [ttk::label $fr1.lfr2.l1 -text [= "LCS1:"]]
     set lab6 [ttk::label $fr1.lfr2.l2 -text [= "LCS2:"]]
     set lab7 [ttk::label $fr1.lfr2.l3 -text [= "LCS3:"]]
     set lab8 [ttk::label $fr1.lfr2.l4 -text [= "YRC1:"]]
     set lab9 [ttk::label $fr1.lfr2.l5 -text [= "YRC2:"]]
     set lab10 [ttk::label $fr1.lfr2.l6 -text [= "YRC3:"]]
     set lab11 [ttk::label $fr1.lfr3.l1 -text [= "Plastic young's modulus:"]]
     set lab12 [ttk::label $fr1.lfr3.l2 -text [= "Plastic yield stress:"]]
     set lab13 [ttk::label $fr1.lfr3.l3 -text [= "Damage deformation factor:"]]
     set lab14 [ttk::label $fr1.lfr4.l1 -text [= "Tangential strength:"]]
     set lab15 [ttk::label $fr1.lfr4.l2 -text [= "Normal tensile strength:"]]
     set lab16 [ttk::label $fr1.lfr4.l3 -text [= "Internal friction angle coeff:"]]
     set lab17 [ttk::label $fr1.lfr1.l5 -text [= "kg/m3"]]
     set lab18 [ttk::label $fr1.lfr1.l6 -text [= "Pa"]]
     set lab19 [ttk::label $fr1.lfr2.l7 -text [= "MPa"]]
     set lab20 [ttk::label $fr1.lfr2.l8 -text [= "MPa"]]
     set lab21 [ttk::label $fr1.lfr2.l9 -text [= "MPa"]]
     set lab22 [ttk::label $fr1.lfr3.l4 -text [= "Pa"]]
     set lab23 [ttk::label $fr1.lfr3.l5 -text [= "MPa"]]
     set lab24 [ttk::label $fr1.lfr4.l4 -text [= "MPa"]]
     set lab25 [ttk::label $fr1.lfr4.l5 -text [= "MPa"]]
     set entrywidth 10
     set ent1 [ttk::entry $fr1.lfr1.e1 -textvariable ::kwiz::wprops(MaterialParameters,Density) -width $entrywidth]
     wcb::callback $fr1.lfr1.e1 before insert wcb::checkEntryForReal
     set ent2 [ttk::entry $fr1.lfr1.e2 -textvariable ::kwiz::wprops(MaterialParameters,YoungModulus) -width $entrywidth]
     wcb::callback $fr1.lfr1.e2 before insert wcb::checkEntryForReal
     set ent3 [ttk::entry $fr1.lfr1.e3 -textvariable ::kwiz::wprops(MaterialParameters,PoissonRatio) -width $entrywidth]
     wcb::callback $fr1.lfr1.e3 before insert wcb::checkEntryForReal
     set ent4 [ttk::entry $fr1.lfr1.e4 -textvariable ::kwiz::wprops(MaterialParameters,ParticleFrictionAngle) -width $entrywidth]
     wcb::callback $fr1.lfr1.e4 before insert wcb::checkEntryForReal
     set ent5 [ttk::entry $fr1.lfr2.e1 -textvariable ::kwiz::wprops(MaterialParameters,LCS1) -width $entrywidth]
     wcb::callback $fr1.lfr2.e1 before insert wcb::checkEntryForReal
     set ent6 [ttk::entry $fr1.lfr2.e2 -textvariable ::kwiz::wprops(MaterialParameters,LCS2) -width $entrywidth]
     wcb::callback $fr1.lfr2.e2 before insert wcb::checkEntryForReal
     set ent7 [ttk::entry $fr1.lfr2.e3 -textvariable ::kwiz::wprops(MaterialParameters,LCS3) -width $entrywidth]
     wcb::callback $fr1.lfr2.e3 before insert wcb::checkEntryForReal
     set ent8 [ttk::entry $fr1.lfr2.e4 -textvariable ::kwiz::wprops(MaterialParameters,YRC1) -width $entrywidth]
     wcb::callback $fr1.lfr2.e4 before insert wcb::checkEntryForReal
     set ent9 [ttk::entry $fr1.lfr2.e5 -textvariable ::kwiz::wprops(MaterialParameters,YRC2) -width $entrywidth]
     wcb::callback $fr1.lfr2.e5 before insert wcb::checkEntryForReal
     set ent10 [ttk::entry $fr1.lfr2.e6 -textvariable ::kwiz::wprops(MaterialParameters,YRC3) -width $entrywidth]
     wcb::callback $fr1.lfr2.e6 before insert wcb::checkEntryForReal
     set ent11 [ttk::entry $fr1.lfr3.e1 -textvariable ::kwiz::wprops(MaterialParameters,PlasticYoungModulus) -width $entrywidth]
     wcb::callback $fr1.lfr3.e1 before insert wcb::checkEntryForReal
     set ent12 [ttk::entry $fr1.lfr3.e2 -textvariable ::kwiz::wprops(MaterialParameters,PlasticYieldStress) -width $entrywidth]
     wcb::callback $fr1.lfr3.e2 before insert wcb::checkEntryForReal
     set ent13 [ttk::entry $fr1.lfr3.e3 -textvariable ::kwiz::wprops(MaterialParameters,DamageDeformationFactor) -width $entrywidth]
     wcb::callback $fr1.lfr3.e3 before insert wcb::checkEntryForReal
     set ent14 [ttk::entry $fr1.lfr4.e1 -textvariable ::kwiz::wprops(MaterialParameters,TangentialStrength) -width $entrywidth]
     wcb::callback $fr1.lfr4.e1 before insert wcb::checkEntryForReal
     set ent15 [ttk::entry $fr1.lfr4.e2 -textvariable ::kwiz::wprops(MaterialParameters,NormalTensileStrength) -width $entrywidth]
     wcb::callback $fr1.lfr4.e2 before insert wcb::checkEntryForReal
     set ent16 [ttk::entry $fr1.lfr4.e3 -textvariable ::kwiz::wprops(MaterialParameters,InternalFrictionAngleCoeff) -width $entrywidth]
     wcb::callback $fr1.lfr4.e3 before insert wcb::checkEntryForReal
     
     # Grid the frames
     grid $fr1 -column 1 -row 0 -sticky nw
     grid $fr2 -column 2 -row 0 
     
     # Set the grid
     grid $lab0 -column 0 -row 0 -sticky w
     grid $labIm -column 0 -row 1 -sticky nw -rowspan 3
     #grid $labIm2 -column 0 -row 2 -columnspan 2 
    
     # Label frames
     grid $labfr1 -column 0 -row 1 -sticky wn -ipadx 10  -columnspan 2
     grid $labfr2 -column 0 -row 2 -sticky wn -ipadx 2  -columnspan 2
     grid $labfr3 -column 0 -row 3 -sticky wn  -columnspan 2
     grid $labfr4 -column 0 -row 4 -sticky wn -ipadx 2  -columnspan 2
     grid $but1 -column 0 -row 5
     grid $but2 -column 1 -row 5 -sticky w
     
     # Label frame 1
     grid $lab1 -column 1 -row 1 -sticky w
     grid $lab2 -column 1 -row 2 -sticky w
     grid $lab3 -column 1 -row 3 -sticky w
     grid $lab4 -column 1 -row 4 -sticky w
     grid $lab17 -column 3 -row 1 -sticky w
     grid $lab18 -column 3 -row 2 -sticky w
     grid $ent1 -column 2 -row 1 -sticky w
     grid $ent2 -column 2 -row 2 -sticky w
     grid $ent3 -column 2 -row 3 -sticky w
     grid $ent4 -column 2 -row 4 -sticky w
     
     # Label frame 2
     grid $lab5 -column 1 -row 1 -sticky w
     grid $lab6 -column 1 -row 2 -sticky w
     grid $lab7 -column 1 -row 3 -sticky w
     grid $lab8 -column 5 -row 1 -sticky w
     grid $lab9 -column 5 -row 2 -sticky w
     grid $lab10 -column 5 -row 3 -sticky w
     grid $lab19 -column 3 -row 1 -sticky w 
     grid $lab20 -column 3 -row 2 -sticky w
     grid $lab21 -column 3 -row 3 -sticky w
     grid $ent5 -column 2 -row 1 -sticky w
     grid $ent6 -column 2 -row 2 -sticky w
     grid $ent7 -column 2 -row 3 -sticky w
     grid $ent8 -column 6 -row 1 -sticky w
     grid $ent9 -column 6 -row 2 -sticky w
     grid $ent10 -column 6 -row 3 -sticky w
     
     # Label frame 3
     grid $lab11 -column 1 -row 1 -sticky w
     grid $lab12 -column 1 -row 2 -sticky w
     grid $lab13 -column 1 -row 3 -sticky w
     grid $lab22 -column 3 -row 1 -sticky w
     grid $lab23 -column 3 -row 2 -sticky w
     grid $ent11 -column 2 -row 1 -sticky w
     grid $ent12 -column 2 -row 2 -sticky w
     grid $ent13 -column 2 -row 3 -sticky w
     
     # Label frame 4
     grid $lab14 -column 1 -row 1 -sticky w
     grid $lab15 -column 1 -row 2 -sticky w
     grid $lab16 -column 1 -row 3 -sticky w
     grid $lab24 -column 3 -row 1 -sticky w
     grid $lab25 -column 3 -row 2 -sticky w
     grid $ent14 -column 2 -row 1 -sticky w
     grid $ent15 -column 2 -row 2 -sticky w
     grid $ent16 -column 2 -row 3 -sticky w
     
     # Grid configure
     grid columnconfigure $win 0 -minsize 10
     grid columnconfigure $win 1 -pad 10
     grid rowconfigure $fr1 5 -pad 20
     grid columnconfigure $fr1.lfr2 4 -minsize 18

}
 
proc ::kwiz::bodystep5 { win } {
    variable wprops
     
     # Set the widgets
     set img1 [::WinUtils::GetImage ExpSelected.gif]
     set lab0 [ttk::label $win.l0 -text [= "General settings:"]]
     set labfr1 [ttk::labelframe $win.lf1 -text [= "Simulation settings"]]
     set labIm1 [ttk::label $win.lf1.li1 -image $img1]
     set lab1 [ttk::label $win.lf1.l1 -text [= "Calculation time:"]]
     set lab2 [ttk::label $win.lf1.l2 -text [= "Delta time selection:"]]
     set lab5 [ttk::label $win.lf1.l5 -text [= "Loading velocity: "]]
     set lab6 [ttk::label $win.lf1.l6 -text [= "Pressure: "]]
     set lab7 [ttk::label $win.lf1.l7 -text [= "sec "]]
     set lab9 [ttk::label $win.lf1.l9 -text [= "m/s "]]
     set lab10 [ttk::label $win.lf1.l10 -text [= "MPa "]]
     set ent1 [ttk::entry $win.lf1.e1 -textvariable ::kwiz::wprops(GeneralSettings,CalculationTime) -width 23]
	 wcb::callback $win.lf1.e1 before insert wcb::checkEntryForReal
     set ent3 [ttk::entry $win.lf1.e3 -textvariable ::kwiz::wprops(GeneralSettings,LoadingVelocity) -width 23]
	 wcb::callback $win.lf1.e3 before insert wcb::checkEntryForReal
     set ::kwiz::wprops(GeneralSettings,Pressure) "0.0"
     set ent4 [ttk::entry $win.lf1.e4 -textvariable ::kwiz::wprops(GeneralSettings,Pressure) -width 23]
	 wcb::callback $win.lf1.e4 before insert wcb::checkEntryForReal
     
     
     set combo [ttk::combobox $win.lf1.c -values [list "Automatic" "Fixed"] -state readonly -width 20]
     
     # Set default value to combo
     $combo set $::kwiz::wprops(GeneralSettings,DeltaTimeSelection)
	 
	 set DTS $::kwiz::wprops(GeneralSettings,DeltaTimeSelection)
	 if {$DTS eq "Automatic" } {
		set statedts "disabled"
	 } else {
		set statedts "normal"
	 }
     set lab4 [ttk::label $win.lf1.l4 -text [= "Delta time:"] -state $statedts]
     set lab8 [ttk::label $win.lf1.l8 -text [= "sec "] -state $statedts]
     set ent2 [ttk::entry $win.lf1.e2 -textvariable ::kwiz::wprops(GeneralSettings,DeltaTime) -state $statedts -width 23]
	 wcb::callback $win.lf1.e2 before insert wcb::checkEntryForReal
	 
     # Set the grid
     grid $lab0 -column 1 -row 0 -sticky w
     
     # Label frame 1
     grid $labfr1 -column 1 -row 1 -sticky w -ipadx 15
     grid $labIm1 -column 0 -row 0 -rowspan 5
     grid $lab1 -column 1 -row 0 -sticky w
     grid $lab2 -column 1 -row 1 -sticky w
     grid $lab4 -column 1 -row 2 -sticky w
     grid $lab5 -column 1 -row 3 -sticky w
     grid $lab7 -column 3 -row 0 -sticky w
     grid $lab8 -column 3 -row 2 -sticky w
     grid $lab9 -column 3 -row 3 -sticky w
     grid $ent1 -column 2 -row 0 -sticky w
     grid $ent2 -column 2 -row 2 -sticky w
     grid $ent3 -column 2 -row 3 -sticky w
     grid $combo -column 2 -row 1 -sticky w
     if { $wprops(ExperimentType,ExperimentType) eq "Triaxial" || $wprops(ExperimentType,ExperimentType) eq "Hydrostatic" } {
        grid $lab6 -column 1 -row 4 -sticky w
        grid $lab10 -column 3 -row 4 -sticky w
        grid $ent4 -column 2 -row 4 -sticky w
     }
            
     # Grid configure
     grid columnconfigure $win 0 -minsize 10
    # grid rowconfigure $win 1 -pad 20
     grid columnconfigure $win.lf1 0 -pad 10
     
     # Combobox frame1 bind
     bind $combo <<ComboboxSelected>> [list ::kwiz::DeltaTimeSelection $win %W]
}

proc ::kwiz::bodystep6 { win } {
    variable wprops
     # Set the widgets
     set img1 [::WinUtils::GetImage ExpSelected.gif]
     set lab0 [ttk::label $win.l0 -text [= "Output settings:"]]
     set labfr1 [ttk::labelframe $win.lf1 -text [= "Nodal results"]]
     set labfr2 [ttk::labelframe $win.lf2 -text [= "Contact mesh results"]]
     set labfr3 [ttk::labelframe $win.lf3 -text [= "Postprocess definition"]]
     set labIm1 [ttk::label $win.lf1.li1 -image $img1]
     set labIm2 [ttk::label $win.lf2.li1 -image $img1]
     set labIm3 [ttk::label $win.lf3.li1 -image $img1]
     set but1 [ttk::checkbutton $win.lf1.b1 -text [= "Displacement"] -variable ::kwiz::wprops(OutputSettings,Displacement)]
     set but2 [ttk::checkbutton $win.lf1.b2 -text [= "Velocity"] -variable ::kwiz::wprops(OutputSettings,Velocity)]
     set but3 [ttk::checkbutton $win.lf1.b3 -text [= "Total forces"] -variable ::kwiz::wprops(OutputSettings,TotalForces)]
     set but4 [ttk::checkbutton $win.lf1.b4 -text [= "Rhs"] -variable ::kwiz::wprops(OutputSettings,Rhs)]
     set but5 [ttk::checkbutton $win.lf1.b5 -text [= "Damp forces"] -variable ::kwiz::wprops(OutputSettings,DampForces)]
     set but6 [ttk::checkbutton $win.lf1.b6 -text [= "Applied forces"] -variable ::kwiz::wprops(OutputSettings,AppliedForces)]
     set but7 [ttk::checkbutton $win.lf2.b1 -text [= "Contact sigma"] -variable ::kwiz::wprops(OutputSettings,ContactSigma)]
     set but8 [ttk::checkbutton $win.lf2.b2 -text [= "Contact tau"] -variable ::kwiz::wprops(OutputSettings,ContactTau)]
     set but9 [ttk::checkbutton $win.lf2.b3 -text [= "Local contact force"] -variable ::kwiz::wprops(OutputSettings,LocalContactForce)]
     set but10 [ttk::checkbutton $win.lf2.b4 -text [= "Failure criterion state"] -variable ::kwiz::wprops(OutputSettings,FailureCriterionState)]
     set but11 [ttk::checkbutton $win.lf3.b1 -text [= "Single postprocess file?"] -variable ::kwiz::wprops(OutputSettings,SinglePostprocessFile)]
     set lab1 [ttk::label $win.lf3.l1 -text [= "Print output file every:"]]
     set lab2 [ttk::label $win.lf3.l2 -text [= "Print graph data every:"]]
     set lab3 [ttk::label $win.lf3.l3 -text [= "seconds"]]
     set lab4 [ttk::label $win.lf3.l4 -text [= "seconds"]]
     set ent1 [ttk::entry $win.lf3.e1 -textvariable ::kwiz::wprops(OutputSettings,PrintOutputFile)]
     wcb::callback $win.lf3.e1 before insert wcb::checkEntryForReal
     set ent2 [ttk::entry $win.lf3.e2 -textvariable ::kwiz::wprops(OutputSettings,PrintGraphData)]
     wcb::callback $win.lf3.e2 before insert wcb::checkEntryForReal
     
     # Set the grid
     grid $lab0 -column 0 -row 0
     grid $labfr1 -row 1 -column 0 -sticky w -padx 30 -ipadx 62
     grid $labfr2 -row 2 -column 0 -sticky w -padx 30 -ipadx 43
     grid $labfr3 -row 3 -column 0 -sticky w -padx 30 -ipadx 10
     
     # Frame 1
     grid $labIm1 -row 0 -column 0 -rowspan 10 -padx 10 -pady 10
     grid $but1 -row 1 -column 1 -sticky w
     grid $but2 -row 2 -column 1 -sticky w
     grid $but3 -row 3 -column 1 -sticky w
     grid $but4 -row 1 -column 2 -sticky w
     grid $but5 -row 2 -column 2 -sticky w
     grid $but6 -row 3 -column 2 -sticky w
     
     # Frame 2
     grid $labIm2 -row 0 -column 0 -rowspan 10 -padx 10 -pady 10
     grid $but7 -row 1 -column 1 -sticky w
     grid $but8 -row 2 -column 1 -sticky w
     grid $but9 -row 1 -column 2 -sticky w
     grid $but10 -row 2 -column 2 -sticky w
     
     # Frame 3
     grid $labIm3 -row 0 -column 0 -rowspan 10 -padx 10 -pady 10
     grid $but11 -row 1 -column 1
     grid $lab1 -row 2 -column 1 -sticky w
     grid $lab2 -row 3 -column 1 -sticky w
     grid $ent1 -row 2 -column 2
     grid $ent2 -row 3 -column 2 
     grid $lab3 -row 2 -column 3
     grid $lab4 -row 3 -column 3
     
     # Grid configure
     grid columnconfigure $win 0 -pad 10
     grid rowconfigure $win 1 -pad 20
     grid rowconfigure $win 2 -pad 20
     grid rowconfigure $win 3 -pad 20
     grid columnconfigure $win.lf1 1 -pad 20
     grid columnconfigure $win.lf2 1 -pad 20
     grid rowconfigure $win.lf1 0 -minsize 10
     grid rowconfigure $win.lf2 0 -minsize 10
     grid rowconfigure $win.lf3 0 -minsize 10
     
     
}

proc ::kwiz::TopWindow { } {
    variable bwinpath
    wm attributes $bwinpath -topmost 1
}

proc ::kwiz::GetMeshPath { ExpType cmeshid } {
     global KPriv
     
     set path ""
     set xmlData $KPriv(xmlWiz)
     set xmlRoot "/Wizard/MeshDB"
     set Nodes [$xmlData selectNodes $xmlRoot]
     foreach node [$Nodes childNodes] {
          if {[$node getAttribute experimenttype ""] eq $ExpType} {
               if {[$node getAttribute id ""] eq $cmeshid} {
                    set path [$node getAttribute modelpath ""]
               }
          }
     }
     return $path
}

proc ::kwiz::PrepareGeom { win } {
     variable wprops
     ::WinUtils::PrintArray wprops
     ::kwiz::NextEvent 6
     
     # Vamos a buscar la malla activa
     if { $wprops(ExperimentType,ExperimentType) eq "BTS" } {
          set ExpType "BTS"
     } else {
          set ExpType "UCS"
     }
     set activemesh $wprops(GeometryMesh,MeshType)
     
     set modelpath [::kwiz::GetMeshPath $ExpType $activemesh]
     
     # Get the model full path
     append fullpath [::KUtils::GetPaths "PFPath"] ".spd"
     
     # Save the model files
     ::kfiles::SaveSPD $fullpath
     
     # Set filetocopy model.wiz
     set filetocopy [::kwiz::SaveActiveWizardtoSPD $fullpath]
     wa "filetocopy $filetocopy"
     set filenamecorrect [lindex [split $filetocopy "."] 0]
     append filenamecorrect ".gid"
      wa " FIlenamecorrect $filenamecorrect"
     # Temporal dir to save model.wiz
     set dir [GidUtils::GetTmp]
     # wa $dir
     if { [file isdirectory $dir] } {
           if { [file exists $filetocopy] } {
                file copy -force -- $filetocopy $dir
           }
     }
     
     set filedest [file join $dir [file tail $filetocopy]]
     if { ![file exists $filedest] } {
           return -1
     }
     
     # Congelamos GiD
     #GidUtils::DisableGraphics
     
     # Conseguimos el path del modelo a cargar
     set cPTpath [::KUtils::GetPaths "PTDir"]
     set meshfull [file join $cPTpath $modelpath]
     # wa "MeshFullpath $meshfull"
     
     # Cargamos el Modelo con los datos de la malla
     GiD_Process File Read $meshfull
     
     # Eliminamos el modelo nuestro ?
     
     # Guardamos con el nombre que toca
     GiD_Process Mescape Files SaveAs -alsoresults:0 -- geoversion:current $filenamecorrect
     
     # Copiamos el wizard.wiz donde toca
     file copy -force -- $filedest $filenamecorrect
     
     # Cargamos el .wiz de disco a memoria
     ::kfiles::LoadWizardData
     
     ::kfiles::SaveWizardToSPD
     GiD_Process Mescape Files Save 

     # Propagar del .wiz al vector y al arbol
     
     #GidUtils::EnableGraphics
     update
     update idletasks
     GiD_Process Mescape Meshing MeshView
     GiD_Process 'Zoom Frame 
     GiD_Process 'Render SmoothLighting
     GidUtils::UpdateWindow "LAYER"
     GidUtils::UpdateWindow "GROUPS"

     $win.lf2.b1 configure -state normal
     $win.lf2.b2 configure -state disabled
     variable editedMesh
     set editedMesh 0
     
     wa "Acabo de transformar"
     ::WinUtils::PrintArray wprops
     global KPriv
     wa [$KPriv(xmlWiz) asXML]
}

proc ::kwiz::RunCalculate { } {
     
    
    # Try to load the new model
    
    GiD_Process Mescape Utilities Calculate
    
    #::kwiz::TopWindow
}

proc ::kwiz::bodystep7 { win } {
     variable wprops
    
     # Set the widgets
     set img1 [::WinUtils::GetImage ExpSelected.gif]
     set labfr1 [ttk::labelframe $win.lf1 -text [= "Run problem"]]
     set labfr2 [ttk::labelframe $win.lf2]
     set labIm1 [ttk::label $win.lf1.li1 -image $img1]
     set lab1 [ttk::label $win.lf1.l1 -text [= "Select OMP/MPI:"]]
     set lab2 [ttk::label $win.lf1.l2 -text [= "Number of threads:"]]
     set ent1 [ttk::entry $win.lf1.e2 -textvariable ::kwiz::wprops(RunProblem,NumberOfThreads) -width 23]
     wcb::callback $win.lf1.e2 before insert wcb::checkEntryForReal     
     set combo [ttk::combobox $win.lf1.c1 -state readonly -values [list OpenMP MPi]]
     
     variable editedMesh
     if {$editedMesh} {
          set runstate "disabled"
          set preparestate "enabled"
     } {
          set runstate "enabled"
          set preparestate "disabled"
     }
     # wa "EditedMesh $editedMesh"
     set but1 [ttk::button $win.lf2.b1 -text [= "Run simulation"] -state $runstate -command [list ::kwiz::RunCalculate] -width 20 ]
     set but2 [ttk::button $win.lf2.b2 -text [= "Prepare Data"] -state $preparestate -command [list ::kwiz::PrepareGeom $win] -width 20]
	 

     # Set default value to combo
     $combo set $::kwiz::wprops(RunProblem,SelectOMPMPI)
     
     # Set the grid
     grid $labfr1 -column 1 -row 1 -sticky w -ipadx 20
     grid $labfr2 -column 1 -row 2 -sticky w -ipadx 20
     grid $labIm1 -column 0 -row 0 -rowspan 2
     grid $but1 -column 1 -row 3
     grid $but2 -column 0 -row 3
	 
      
     # Frame 1
     grid $lab1 -column 1 -row 0 -sticky w
     grid $lab2 -column 1 -row 1 -sticky w
     grid $combo -column 2 -row 0 -sticky w
     grid $ent1 -column 2 -row 1 -sticky w
    
     
     # Configure the grid
     grid columnconfigure $win 0 -minsize 10
     grid rowconfigure $win 2 -minsize 20
     grid columnconfigure $win.lf1 0 -pad 10
     grid columnconfigure $win.lf2 0 -pad 150
     grid rowconfigure $win 1 -pad 15
     
     
     # Combobox frame1 bind
     bind $combo <<ComboboxSelected>> [list ::kwiz::ParallelTypeSelection $win %W]
}

proc ::kwiz::generateRandomPoints { } {
     set rlist [list 1 1 2 2 3 3 4 4 5 5 10 6 11 4 13 9 15 11 16 16]
     set pvalues [list ]
     foreach {x y} $rlist {
          lappend pvalues [list $x $y]
     }
     return $pvalues
}

proc ::kwiz::bodystep8 { win } {
     variable wprops
     # Set the widgets
     
     set labfr1 [ttk::labelframe $win.lf1 -text [= "Result View"]]
     set labfr2 [ttk::frame $win.lf2]
     set graframe [ttk::frame $win.graframe]
     set logframe [ttk::frame $win.logframe]
     
     set but1 [ttk::button $win.lf2.b1 -text [= "Refresh Graph"] -command [list ::kwiz::Terminate] -width 20]
     set but2 [ttk::button $win.lf2.b2 -text [= "Terminate"] -command [list ::kwiz::Terminate] -width 20]
     
     set lab1 [ttk::label $win.lf1.l1 -text [= "Select Graph"]]
     set combo [ttk::combobox $win.lf1.c1 -state readonly -values [list Graph1]]
     # Set default value to combo
     $combo set $::kwiz::wprops(ResultView,Graph1)
     
     set pvalues [::kwiz::generateRandomPoints]  
     set cpath [canvas $graframe.c -relief sunken -borderwidth 2 ]
     set title [= "Ejemplo"]
     set xlabel "xlabel"
     set ylabel "ylabel"
     ::KPlot::Plot $cpath $pvalues $title $xlabel $ylabel
     
     set log [tk::text $logframe.log -height 4]
     $log insert 1.0 "abcdefghi\n"
     $log insert 2.0 "123456789\n"
     # Significa instertar este texto en la linea 2, caracter inicial 0
     $log configure -state disabled
     
     # Set the grid
     grid $labfr1 -column 1 -row 0 -sticky we -ipadx 20
     grid $labfr2 -column 1 -row 1 -sticky we -ipadx 20
     grid $cpath -in $graframe -sticky ew
     grid $graframe -column 1 -row 2 -sticky wes
     grid $logframe -column 1 -row 3 -sticky nsew	 
     
     # Frame 1
     grid $lab1 -column 1 -row 0 -sticky w
     grid $combo -column 2 -row 0 -sticky w
     
     # Frame Botones
     grid $but1 -column 1 -row 1
     grid $but2 -column 2 -row 1
     
     # Frame Log
     grid $log -sticky ew
           
     # Configure the grid
     grid columnconfigure $win 0 -minsize 10
     grid rowconfigure $win 2 -minsize 20
     grid columnconfigure $win.lf1 0 -pad 10
     grid columnconfigure $win.lf2 0 -pad 150
     grid rowconfigure $win 1 -pad 15
     update 
     #::kwiz::WhileCalculation $log 
}

proc ::kwiz::writeToLog {log msg} {
     if {[winfo exists $log]} {
          set numlines [lindex [split [$log index "end - 1 line"] "."] 0]
          $log configure -state normal
          if {$numlines==4} {$log delete 1.0 2.0}
          if {[$log index "end-1c"]!="1.0"} {$log insert end "\n"}
          $log insert end "$msg"
          $log configure -state disabled
          return 1
     } else {
          return 0
     }
}

proc ::kwiz::WhileCalculation { log } {
     set cont 1
     wa "While Calculation"
     set infofile [string range $::kfiles::fname 0 end-4]
     set infofile [ append infofile ".info"]
     while { $cont } {
          set f [open $infofile RDONLY]
          catch {seek $f -1024 end}
          while {![eof $f]} {
               update idletasks
               #wa "Long [string length [gets $f]]"
               set line [gets $f]
               set cont [::kwiz::writeToLog $log $line]
               if {$line eq "ANALYSIS COMPLETED"} {
                    set cont 0
               }
              
          }
          close $f
          update idletasks
          after 1000
          update
     }
}

proc ::kwiz::Terminate { } {
     GiD_Process Utilities CancelProcess
}

#-np- ::kwiz::CreateDEMWizard
 proc ::kwiz::CreateDEMWizard { } {
     variable bwinpath
     variable wprops
     # Destroy the window 
     if {[winfo exists $bwinpath]} {
          destroy $bwinpath
     }
     # wa "bwinpath:$bwinpath"
     # Create the window
     InitWindow $bwinpath [= "DEM Wizard"] Pre::kwiz::CreateDEMWizardWindowGeom
	
     # Centrar window
     wm withdraw $bwinpath
     
     set x [expr {([winfo screenwidth .gid.central.s]-[winfo width .gid.central.s])/2}]
     set y [expr {([winfo screenheight .gid.central.s]-[winfo height .gid.central.s])/2}]
     if { $x < 0 } { set x 0 }
     if { $y < 0 } { set y 0 }
     WmGidGeom $bwinpath +$x+$y
     update
     wm deiconify $bwinpath

        
     wm minsize $bwinpath 550 430
     wm maxsize $bwinpath 860 780
         
     variable stepidlist
     set stepidlist [list ::kwiz::step1 ::kwiz::step2 ::kwiz::step3 ::kwiz::step4 ::kwiz::step5 ::kwiz::step6 ::kwiz::step7 ::kwiz::step8]
    
     # First destroy all defined command (snit step data type)
     foreach cmdid [info commands ::kwiz::step*] {
          $cmdid destroy
     }
     
     # Create all the steps
     ::snitwiz::wizardstep ::kwiz::step1 -title [= "Dempack on Kratos"] -body {::kwiz::bodystep1 $win}
    
     ::snitwiz::wizardstep ::kwiz::step2  -title [= "Step 2"] -layout basic -body {::kwiz::bodystep2 $win}
     #
     ::snitwiz::wizardstep ::kwiz::step3  -title [= "Step 3"] -layout basic -body {::kwiz::bodystep3 $win}
     #
    ::snitwiz::wizardstep ::kwiz::step4  -title [= "Step 4"] -layout basic -body {::kwiz::bodystep4 $win}
     #
     ::snitwiz::wizardstep ::kwiz::step5  -title [= "Step 5"] -layout basic -body {::kwiz::bodystep5 $win}
     #
     ::snitwiz::wizardstep ::kwiz::step6  -title [= "Step 6"] -layout basic -body {::kwiz::bodystep6 $win}
     #
     ::snitwiz::wizardstep ::kwiz::step7  -title [= "Step 7"] -layout basic -body {::kwiz::bodystep7 $win}
     
     ::snitwiz::wizardstep ::kwiz::step8  -title [= "Step 8"] -layout basic -body {::kwiz::bodystep8 $win}
    
     # Render the wizard
     ::snitwiz::wizard $bwinpath.w -steps $stepidlist
     
     #::snitwiz::disablenext
     $bwinpath.w buttonstate next disabled
     
     # Start the wizard
     $bwinpath.w start
    
    
     #::snitwiz::disablenext
     .gid.wtest.w buttonstate next disabled
}


 
 
